﻿using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Optimization;

namespace HeuristicLab.Problems.ProgramSynthesis {
  public interface IPlushCreator : ISolutionCreator, IPlushOperator {
    IValueLookupParameter<IntValue> MinLengthParameter { get; }
    IValueLookupParameter<IntValue> MaxLengthParameter { get; }
    IValueLookupParameter<IntValue> MaxCloseParameter { get; }
    IValueLookupParameter<DoubleValue> CloseBiasLevelParameter { get; }
    IValueLookupParameter<PercentValue> InInstructionProbabilityParameter { get; }
    IValueLookupParameter<IReadOnlyErcOptions> ErcOptionsParameter { get; }
    IValueLookupParameter<IReadOnlyExpressionsConfiguration> InstructionsParameter { get; }
    ILookupParameter<PlushVector> PlushVectorParameter { get; }
  }
}
